#!/bin/sh

PRJ_line="-------------------------------------------------------------------------------";
PRJ_switch="$1"
PRJ_local_script="$0"
PRJ_local_path="$(dirname "$0")"
PRJ_local_cfg="${PRJ_local_path}/ahr_ide.cfg"

PRJ_config () {
        echo "Loading Configuration for Project:";
        # load config name and other
        PRJ_name=$(grep "PRJ_name" $PRJ_local_cfg | awk -F : '{ print $1 }')
        PRJ_category=$(grep "PRJ_name" $PRJ_local_cfg | awk -F : '{ print $3 }')
        PRJ_path=$(grep "PRJ_name" $PRJ_local_cfg | awk -F : '{ print $4 }')
        PRJ_editor=$(grep "PRJ_name" $PRJ_local_cfg | awk -F : '{ print $5 }')
        PRJ_mk_file=$(grep "PRJ_mk_file" $PRJ_local_cfg | awk -F : '{ print $4 }')

        # reconfig path
        PRJ_path="${PRJ_path}/${PRJ_category}/${PRJ_name}"
        
        PRJ_scripts

}

PRJ_scripts () {
        PRJ_scr_array=$(grep "script:" $PRJ_local_cfg | awk -F : '{ print $2 }')
        PRJ_scr_count=0; i=""; j=0; s="";
        
        for i in $PRJ_scr_array; do
                PRJ_scr_count=$(expr $PRJ_scr_count + 1)
                PRJ_scr_target=$(grep "${i}:" $PRJ_local_cfg | awk -F : '{ print $6 }')
                PRJ_scr_file=$(grep "${i}:" $PRJ_local_cfg | awk -F : '{ print $4 }')
                printf "\t[${PRJ_scr_count}] ${PRJ_scr_target}  ${PRJ_scr_file}\n";
        done
        printf "Enter the script referenced number to work with [${PRJ_scr_count}]: ";
        read PRJ_scr_selection
        
        # if empty READ=PRJ_scr_count
        if [ -z "${PRJ_scr_selection}" ]; then
                PRJ_scr_selection=$(expr $PRJ_scr_count)

        fi

        # set variables for selection
        for s in $PRJ_scr_array; do
                j=$(expr $j + 1)
                if [ "${PRJ_scr_selection}" == "${j}" ]; then
                        PRJ_scr_var="${s}"
                        PRJ_scr_target=$(grep "${s}:" $PRJ_local_cfg | awk -F : '{ print $6 }')
                        PRJ_scr_file=$(grep "${s}:" $PRJ_local_cfg | awk -F : '{ print $4 }')
                        
                fi
        done
        
}

PRJ_var_show () {
        echo " PRJ_name:        ${PRJ_name}"
        echo " PRJ_category:    ${PRJ_category}"
        echo " PRJ_path:        ${PRJ_path}"
        echo " PRJ_editor:      ${PRJ_editor}"
        echo " PRJ_local_path:  ${PRJ_local_path}"
        echo " PRJ_mk_file:     ${PRJ_mk_file}"
        echo " PRJ_scr_var:     ${PRJ_scr_var}"
        echo " PRJ_scr_target:  ${PRJ_scr_target}"
        echo " PRJ_scr_file:    ${PRJ_scr_file}"
        echo $PRJ_line
        cat $PRJ_local_cfg
}
# -----------------------------------------------------------------------------
PRJ_compile () {

        if [ "${PRJ_scr_var}" == "PRJ_mk_file" ]; then
                PRJ_help compile Makefile
        else
                echo $PRJ_line;
                echo "COMPILE: ${PRJ_scr_var} ${PRJ_scr_target} ${PRJ_scr_file}"
                if [ -e "${PRJ_scr_file}" ]; then
                        cd $PRJ_path; make "${PRJ_scr_target}"; sleep 2;
                        cd $PRJ_local_path; echo "";
                else
                        PRJ_help compile source-missing
                fi

        fi
}

PRJ_testdrive () {

        if [ "${PRJ_scr_var}" == "PRJ_mk_file" ]; then
                PRJ_help testdrive Makefile
        else
                clear; echo $PRJ_line;
                printf "Executing Compilation of ${PRJ_scr_target}:\n\n"
                cd $PRJ_path;
                if [ -e "${PRJ_scr_target}" ]; then
                        ./"${PRJ_scr_target}";
                        sleep 2; cd $PRJ_local_path;
                        echo $PRJ_line; echo "";
                else
                        cd $PRJ_local_path;
                        PRJ_help testdrive target-missing
                fi

        fi

}

PRJ_edit () {
        PRJ_edt_call="${PRJ_editor} ${PRJ_scr_file}"
        $PRJ_edt_call
}

PRJ_help () {
        PRJ_hlp_key="$1"
        PRJ_hlp_val="$2"
        if [ "${PRJ_hlp_key}" == "compile" ]; then
                if [ "${PRJ_hlp_val}" == "source-missing" ]; then
                        echo ""; echo $PRJ_line; echo "";
                        printf "\tSource File is missing --  "
                        printf "use ${PRJ_local_script} -e to edit script file\n\n"
                elif [ "${PRJ_hlp_val}" == "Makefile" ]; then
                        echo ""; echo $PRJ_line; echo "";
                        printf "\t Cannot compile Makefile -- "
                        printf "use ${PRJ_local_script} -e to edit Makefile\n\n"
                fi

        elif [ "${PRJ_hlp_key}" == "processor" ]; then
                if [ "${PRJ_hlp_val}" == "switch-missing" ]; then
                        echo ""; echo $PRJ_line; echo "";
                        printf "\t [switch-missing]\n"; PRJ_switches;
                elif [ "${PRJ_hlp_val}" == "unknown-switch" ]; then
                        echo ""; echo $PRJ_line; echo "";
                        printf "\t [unknown-switch]\n"; PRJ_switches;
                fi
                
        elif [ "${PRJ_hlp_key}" == "testdrive" ]; then
                if [ "${PRJ_hlp_val}" == "Makefile" ]; then
                        echo ""; echo $PRJ_line; echo "";
                        printf "\t Cannot execute Makefile -- "
                        printf "use ${PRJ_local_script} -e to edit Makefile\n\n"
                elif [ "${PRJ_hlp_val}" == "target-missing" ]; then
                        echo ""; echo $PRJ_line; echo "";
                        printf "\tTarget File is missing -- "
                        printf "make sure you compile first and then execute\n\n"
                fi
        else
                echo $PRJ_line
                echo "HELP: none yet"

        fi

}

PRJ_switches () {
        printf "\t\tAllowed Switches:\n"
        printf "\t\t\tCompile -c:\n"
        printf "\t\t\tExecute -x:\n"
        printf "\t\t\tEdit -e:\n\n\n"
}

PRJ_processor () {
        clear
        echo $PRJ_line
        if [ -e "${PRJ_local_cfg}" ]; then
                # load config
                PRJ_config
                
                # show variables
                PRJ_var_show
                
                # switches
                if [ ! -z "${1}" ]; then
                        if [ "${1}" == "-c" ]; then
                                PRJ_compile
                        elif [ "${1}" == "-x" ]; then
                                PRJ_testdrive
                        elif [ "${1}" == "-e" ]; then
                                PRJ_edit
                        else
                                PRJ_help processor unknown-switch
                        fi
                else
                        PRJ_help processor switch-missing
                fi
        else
                echo "Configuration not found! Run Setup!"
        fi
}

PRJ_processor $PRJ_switch

