#!/bin/sh

PRJ_sim="simulation"; # replace with real/simulation
PRJ_local_script="$0"
PRJ_local_path="$(dirname "$0")"
PRJ_local_cfg="${PRJ_local_path}/ahr_ide.cfg"
PRJ_local_ahr="${PRJ_local_path}/ahr_ide.sh"

PRJ_input () { # input questions
        q="$1"
        if [ "${q}" == "name" ]; then
                printf "Enter Project Name for C Language programming [ahr]:"
                read q_name
                if [ ! -z "$q_name" ] ; then
                        PRJ_save name $q_name
                else
                        PRJ_save name ahr
                fi

        elif [ "${q}" == "category" ]; then
                printf "Enter Category of Project [projects]:"
                read q_category
                if [ ! -z "$q_category" ] ; then
                        PRJ_save category $q_category
                else
                        PRJ_save category projects
                fi

        elif [ "${q}" == "path" ]; then
                printf "Enter Path to Project [/usr/ports]:"
                read q_path
                if [ ! -z "$q_path" ] ; then
                        PRJ_save path $q_path
                else
                        PRJ_save path /usr/ports
                fi

        elif [ "${q}" == "editor" ]; then
                printf "What Text Editor to use for opening file/s [ee]:"
                read q_editor
                if [ ! -z "$q_path" ] ; then
                        PRJ_save editor $q_editor
                else
                        PRJ_save editor ee
                fi

        elif [ "${q}" == "done" ]; then
                PRJ_save done default done
        fi

}
PRJ_save () {
        PRJ_field="$1"; PRJ_value="$2";
        if [ "${PRJ_field}" == "done" ]; then
                # further validation of array or just save

                if [ "${PRJ_sim}" == "real" ]; then
                        printf "\tWRITE: ${PRJ_cache}\n\n";
                        echo ""
                        PRJ_create ${PRJ_cache}
                        
                else
                        printf "\tSAVE: ${PRJ_cache}\n";

                        # continue simulation
                        PRJ_name=$(echo "$PRJ_cache" | awk -F : '{ print $1 }')
                        PRJ_category=$(echo "$PRJ_cache" | awk -F : '{ print $3 }')
                        PRJ_path=$(echo "$PRJ_cache" | awk -F : '{ print $4 }')

                        PRJ_ck_dir=$(echo "$PRJ_path" | sed -e "s/\// \//ig")
                        PRJ_ck_dir="${PRJ_ck_dir} /${PRJ_category} /${PRJ_name}"

                        for i in $PRJ_ck_dir; do
                                PRJ_ck_add="${PRJ_ck_add}${i}";
                                PRJ_mkdir $PRJ_ck_add
                        done
                        
                        # reconfig path
                        PRJ_path="${PRJ_path}/${PRJ_category}/${PRJ_name}"
                        
                        # Makefile
                        PRJ_mk_file="${PRJ_path}/Makefile"
                        PRJ_makefile $PRJ_mk_file
                        
                        # default script C lang
                        PRJ_welcome="${PRJ_path}/welcome.c"
                        PRJ_rawcode $PRJ_welcome
                        
                        PRJ_chg_file
                        
                        echo ""
                        echo "*** END SIMULATION ***"
                fi
        else
                if [ "$PRJ_field" == "name" ]; then
                        PRJ_cache="${PRJ_value}:PRJ_name"
                else
                        PRJ_cache="${PRJ_cache}:${PRJ_value}"
                fi

                printf "\tCACHE: ${PRJ_cache}\n\n";
        fi
}
PRJ_questions () {
        PRJ_data="name category path editor done"
        for i in $PRJ_data; do
                PRJ_input $i
        done
}
PRJ_create () {
        if [ ! -e "${PRJ_local_cfg}" ]; then
                touch ${PRJ_local_cfg}
                echo "$1" > $PRJ_local_cfg
                sleep 1

        fi
        # load config name and other
        PRJ_name=$(grep "PRJ_name" $PRJ_local_cfg | awk -F : '{ print $1 }')
        PRJ_category=$(grep "PRJ_name" $PRJ_local_cfg | awk -F : '{ print $3 }')
        PRJ_path=$(grep "PRJ_name" $PRJ_local_cfg | awk -F : '{ print $4 }')
        PRJ_editor=$(grep "PRJ_name" $PRJ_local_cfg | awk -F : '{ print $5 }')

        # check and create folder structure
        PRJ_ck_dir=$(echo "$PRJ_path" | sed -e "s/\// \//ig")
        PRJ_ck_dir="${PRJ_ck_dir} /${PRJ_category} /${PRJ_name}"
        
        echo "STRUCTURE:"
        for i in $PRJ_ck_dir; do
                PRJ_ck_add="${PRJ_ck_add}${i}";
                PRJ_mkdir $PRJ_ck_add
        done

        # reconfig path
        PRJ_path="${PRJ_path}/${PRJ_category}/${PRJ_name}"
        
        # Makefile
        PRJ_mk_file="${PRJ_path}/Makefile"
        PRJ_makefile $PRJ_mk_file
        echo ""
        echo "FILE: ${PRJ_mk_file}"
        cat $PRJ_mk_file
        echo "${PRJ_name}:PRJ_mk_file:script:${PRJ_mk_file}:${PRJ_editor}:Makefile" >> $PRJ_local_cfg

        # default script C lang
        PRJ_welcome="${PRJ_path}/welcome.c"
        PRJ_rawcode $PRJ_welcome
        echo ""
        echo "FILE: ${PRJ_welcome}"
        cat $PRJ_welcome
        echo "${PRJ_name}:PRJ_welcome:script:${PRJ_welcome}:${PRJ_editor}:welcome" >> $PRJ_local_cfg
        
        echo ""
        echo "FILE: ${PRJ_local_cfg}"
        cat $PRJ_local_cfg
        
        PRJ_chg_file
        
}

PRJ_mkdir () {

        if [ ! -d "$1" ]; then
                printf "\tNEW: ${1} \n"
                if [ "${PRJ_sim}" == "real" ]; then
                        mkdir $1
                fi
        else
                printf "\tDIR: ${1} \n"
        fi
}

PRJ_config () {
        echo "Loading Configuration for Project:";
        # load config name and other
        PRJ_name=$(grep "PRJ_name" $PRJ_local_cfg | awk -F : '{ print $1 }')
        PRJ_category=$(grep "PRJ_name" $PRJ_local_cfg | awk -F : '{ print $3 }')
        PRJ_path=$(grep "PRJ_name" $PRJ_local_cfg | awk -F : '{ print $4 }')
        PRJ_editor=$(grep "PRJ_name" $PRJ_local_cfg | awk -F : '{ print $5 }')
        PRJ_mk_file=$(grep "PRJ_mk_file" $PRJ_local_cfg | awk -F : '{ print $4 }')

        # reconfig path
        PRJ_path="${PRJ_path}/${PRJ_category}/${PRJ_name}"
        
}

PRJ_makefile () {
        if [ "${PRJ_sim}" == "real" ]; then
                # Ziria's Makefile
                if [ ! -e "${1}" ]; then
                        touch ${1}
                        echo ".c:" > ${1}
                        printf '\t$(CC) -o \$\@ \$\<\n' >> ${1}
                fi
        else
                echo "FILE: ${1}"
                echo ".c:"; printf "\t"; echo '\$(CC) -o \$@ \$<\n';
                echo ""
        fi
}

PRJ_rawcode () {
        if [ "${PRJ_sim}" == "real" ]; then
                if [ ! -e "${1}" ]; then
                        touch ${1}
                        printf '#include <stdio.h>\n\n' > ${1}
                        echo "int main(void) {" >> ${1}
                        printf '\tprintf("Welcome to C programming!\\n");\n\treturn 0;\n}\n' >> ${1}
                fi
        else
                echo "FILE: ${1}"
                echo "#include <stdio.h>"
                echo ""
                echo "int main(void) {"
                printf '\tprintf("Welcome to C programming!\\n");\n\treturn 0;\n}\n'
        fi
}

PRJ_chg_file () {
        # easy to operate by typing "project_name switch"
        PRJ_chg_name="${PRJ_local_path}/${PRJ_name}.sh"
        if [ "${PRJ_sim}" == "real" ]; then
                if [ -e "${PRJ_local_ahr}" ]; then
                        cp $PRJ_local_ahr $PRJ_chg_name
                        if [ ! -x "${PRJ_chg_name}" ]; then
                                chmod +x ${PRJ_chg_name}
                        fi
                        
                        rm $PRJ_local_ahr
                else
                        echo ""; echo "File doesn\'t exist: ${PRJ_local_ahr}"; echo "";
                fi
        else
                echo ""
                printf "\tCOPY: ${PRJ_local_ahr} to ${PRJ_chg_name}\n";
                printf "\tCHMOD -x: ${PRJ_chg_name}\n";
                printf "\tREMOVE: ${PRJ_local_ahr}\n\n\n";
                
        fi

}
PRG_setup () {
        clear
        if [ -e "${PRJ_local_cfg}" ]; then
                # load config
                PRJ_config
        else
                # assume new config
                PRJ_questions
        fi
}

PRG_setup
echo ""; echo ""


